#ifndef _BLOC_MONOPOMPE_H
#define _BLOC_MONOPOMPE_H

#include "mbed.h"
#include "ident_crac.h"

#define PWM_STOP_POMPE 0
#define PWM_POMPE 0.7
#define ELEC_FERME 1 
#define ELEC_OUVERTE 0
#define SEUIL_CPT 0.1

class bloc_monopompe 
{
    public :
            bloc_monopompe (PinName pompe, PinName electrovanne, PinName capteur) ;
            
            void aspirer (void) ;
            
            void relacher (void) ;
            
            char etat_actuel (void) ;
            
            void stop_pompe (void);
            
    private :
            
            PwmOut _pompe ;
            DigitalOut _electrovanne ;
            AnalogIn _capteur ;
            
            float _val_cpt ;
            bool _gobelet_en_place ;
};

#endif